function A = system_matrix(x,N);

global epsilon

% Discrete Laplace part
h = (x(2:end)-x(1:end-1)); % h(i) = x(i+1)-x(i)

md = 1./h(2:end) + 1./h(1:end-1); % main diagonal
ud = -1./h(1:end-1); % upper diagonal, shift due to spdiags
ld = -1./h(2:end); % lower diagonal; shift due to spdiags

% construct the matrix
% Lap approximates int(DxU*DxPhi)
Lap = spdiags([ud md ld],[1 0 -1],N,N);


% dxu part
% Dx approximates int(U*DxPhi)
dg = 0.5*ones(N,1);
Dx = spdiags([dg -dg],[-1 1],N,N);

% System matrix 
A = -epsilon*Lap + Dx;
